博客
关于我
强烈建议你试试无所不能的chatGPT,快点击我
Codeforces Round #247 (Div. 2) D. Random Task
阅读量:6838 次
发布时间:2019-06-26

本文共 2247 字,大约阅读时间需要 7 分钟。

D. Random Task
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

One day, after a difficult lecture a diligent student Sasha saw a graffitied desk in the classroom. She came closer and read: "Find such positive integer n, that among numbers n + 1n + 2, ..., n there are exactly m numbers which binary representation contains exactly kdigits one".

The girl got interested in the task and she asked you to help her solve it. Sasha knows that you are afraid of large numbers, so she guaranteed that there is an answer that doesn't exceed 1018.

Input

The first line contains two space-separated integers, m and k (0 ≤ m ≤ 10181 ≤ k ≤ 64).

Output

Print the required number n (1 ≤ n ≤ 1018). If there are multiple answers, print any of them.

Sample test(s)
input
1 1
output
1
input
3 2
output
5

题意:

求一个n,使得n+1到2n这些数的二进制中恰好有k个1的数有m个。

思路:

在k同样的情况下。打表之后发现单调性,能够二分。

问题转化为n+1到2n二进制表示之后1的个数为k的有多少个?

进一步统一。假设知道区间[0,x]内的二进制表示之后1的个数为k有cal(x)个,那么答案就是cal(2n)-cal(n)了。

如今要 求cal(x)。

假设x为  101101 ,k=3。

由于求比小于等于x的数二进制表示之后1的个数为k的有多少个,所以当第一位为0的时候,后面5位中须要3位为0才干满足条件,C[5][3],前两位同样。第三位为0的时候,前面已经有2个1。后面三位仅仅需1个1就可以,C[3][1]...

从样例中你应该能得出结论了吧。

逐位枚举。如果前d为同样,已有num个1,该位为1,我们能够将该位置0(由于求的是[0,x]内的二进制表示之后1的个数为k有多少个),那么后面还须要k-num个1,后面还有i为的话,那么ans+= C[i][k-num]。

代码:

#include 
#include
#include
#include
#include
#include
#include
#include
#include
#include
#include
#pragma comment (linker,"/STACK:102400000,102400000")#define maxn 15#define MAXN 100005#define OO (1LL<<35)-1#define mod 1000000007#define INF 0x3f3f3f3f#define pi acos(-1.0)#define eps 1e-6typedef long long ll;using namespace std;ll n,m,k,d,ans,tot,flag,cnt;ll C[70][70];ll cal(ll x){ ll i,j,res=0,num=0; for(i=62;i>=0;i--) { if(x&(1LL<
=0) res+=C[i][k-num]; num++; } } return res;}int main(){ ll i,j,t,le,ri,mid,cnt; for(i=0;i<=64;i++) C[i][0]=1; for(i=1;i<=64;i++) { for(j=1;j<=i;j++) { C[i][j]=C[i-1][j]+C[i-1][j-1]; } } while(cin>>m>>k) { le=1; ri=1LL<<62; while(le<=ri) { mid=(le+ri)>>1; cnt=cal(2*mid)-cal(mid); if(m<=cnt) { ans=mid; ri=mid-1; } else le=mid+1; } cout<
<

转载于:https://www.cnblogs.com/yutingliuyl/p/6696217.html

你可能感兴趣的文章
tensorflow 1.0 学习:十图详解tensorflow数据读取机制
查看>>
Go语言建立一个最简单的服务端点
查看>>
Android提示版本号更新操作流程
查看>>
Android中Handler的使用
查看>>
swift-初探webView与JS交互
查看>>
Object-C与Swift混合开发
查看>>
(转)C#开发微信门户及应用(4)--关注用户列表及详细信息管理
查看>>
Nginx(九)-- Nginx实际使用配置
查看>>
推断给定的IP地址是否是内网IP
查看>>
Blend for Visual Studio 2013
查看>>
线程同步的几种方式
查看>>
javascript跳跃式前进(3) - 跳入JSON
查看>>
Brackets
查看>>
aac格式介绍
查看>>
Java 9 揭秘(16. 虚拟机栈遍历)
查看>>
iOS10 推送通知 UserNotifications
查看>>
Android UI开发神兵利器之Icon
查看>>
取给定正整数的指定bit位開始的指定长度的数据
查看>>
为什么说一知半解的人生最可怕?
查看>>
PARSEC測试集的应用领域和working set的大小
查看>>